#ifndef COFFEE_MACHINE_H
#define COFFEE_MACHINE_H

#include <stdlib.h>
#include <stdbool.h>
#include "state.h"
#include "io.h"
#include "mooremachine.h"

#define TIMEOUT 5000000
#define TIMELIMIT 1500000

#define NUM_OF_STATES 4
#define NUM_OF_INPUTS 2
#define NUM_OF_OUTPUTS 3

/* I/O Pin Definition  */
#define IN_START_BUTTON_PIN 7
#define IN_CUP_READY_PIN 0
#define OUT_CUP_PIN 4
#define OUT_COFFEE_PIN 5
#define OUT_READY_LED_PIN 6

/* States */
#define STANDBY        0
#define SUPPLY_CUP     1
#define SUPPLY_COFFEE  2
#define READY          3

/* Outputs */
#define OUT_CUP       0
#define OUT_COFFEE	  1
#define OUT_READY_LED 2

/* inputs */
#define IN_START_BUTTON 0
#define IN_CUP_READY    1

void begin_cycle(void* p);

/*
* Functions to read and write io
*/
void read_input(void* in);
void write_output(void* out);

//Init function
void initialize(moore_t* m);


#endif /* COFFEE_MACHINE_H */
